//======================================
var scriptName= "CloneItem+";
var scriptVer = "1.0";
var author = "F.Ichikawa";
var contact = "f_ichikawa@livedoor.com";
var updatedby = "Ernest Chan";
//ernpchan@gmail.com
//======================================
@version 2.4
@warnings
@script generic
@name "CloneItem+"
@strict

var selected;
var c1;
var Descendents;
var numClones = 1;
var DescendentsToggle = false;
var DescendentsCheck;

generic
{
    reqbegin(scriptName+" "+scriptVer);
    reqsize(200,100);
    c1 = ctlminislider("  Number of Clones",numClones,1,1000);
	Descendents = ctlcheckbox("Clone Descendents",DescendentsToggle);
    ctlrefresh(c1,"CheckNClones");
	ctlposition(c1,5,10);
	ctlposition(Descendents,5,35);
    if(!reqpost()) return;
    numClones = getvalue(c1);
	DescendentsCheck = getvalue(Descendents);
    reqend();

	GetIndependentSelected();
	
	if(DescendentsCheck == 1){
		if(!selected) return;
		while(numClones > 0){
			var i;
			for(i = 1;i <= size(selected);i++){
				var s = selected[i];
				if(s){
                CloneWithAllSubItems(s,s.parent);
            }
        }
        numClones--;
		}
	}
	else{
		if(!selected) return;
	    while(numClones > 0){
			var i;
			for(i = 1;i <= size(selected);i++){
				var s = selected[i];
				if(s){
					Clone(1);
				}
			}
        numClones--;
		}
    
	}
}

CheckNClones:v
{
    if(v <= 0 || v > 100){
        setvalue(c1,numClones);
    }else{
        numClones = v;
    }
}

GetIndependentSelected
{
    selected = Scene().getSelect();
    if(selected == nil) return;
    var i;
    for(i = 1;i <= size(selected);i++){
        if(IsDependant(selected[i])){
            selected[i] = false;
        }
    }
}

IsDependant:i
{
    var p = i.parent;
    while(p != nil){
        if(p.selected) return true;
        p = p.parent;
    }
    return false;
}

CloneWithAllSubItems:i,newParent
{
    SelectItem(i.id);
    Clone(1);
    var cloned;
    (cloned) = Scene().getSelect();
    if(newParent){
        ParentItem(newParent.id);
    }
    var child;
    if(i.isMesh()){
        var sBone = i.bone();
        var dBone = cloned.bone();
        while(sBone != nil){
            child = sBone.firstChild();
            while(child != nil){
                if(!child.isBone()){
                    CloneWithAllSubItems(child,dBone);
                }
                child = sBone.nextChild();
            }
            sBone = sBone.next();
            dBone = dBone.next();
        }
    }
    child = i.firstChild();
    while(child != nil){
        if(!i.isMesh() || !child.isBone()){
            CloneWithAllSubItems(child,cloned);
        }
        child = i.nextChild();
    }
}

Cont:m
{
    reqbegin("Continue");
    ctltext("",m);
    if(!reqpost()) error("Aborted!");
    reqend();
}